package org.dromara.payment.sys.service;

import jakarta.validation.constraints.NotNull;
import org.dromara.common.core.domain.R;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.payment.sys.domain.bo.SysSydAccountBo;
import org.dromara.payment.sys.domain.vo.SysSydAccountVo;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.Collection;
import java.util.List;

/**
 * 服务商账户Service接口
 *
 * @author LionLi
 * @date 2024-03-26
 */
public interface ISysSydAccountService {

    /**
     * 查询服务商账户
     */
    SysSydAccountVo queryById(Long id);

    /**
     * 查询服务商账户列表
     */
    TableDataInfo<SysSydAccountVo> queryPageList(SysSydAccountBo bo, PageQuery pageQuery);

    /**
     * 查询服务商账户列表
     */
    List<SysSydAccountVo> queryList(SysSydAccountBo bo);

    /**
     * 新增服务商账户
     */
    Boolean insertByBo(SysSydAccountBo bo);

    /**
     * 修改服务商账户
     */
    Boolean updateByBo(SysSydAccountBo bo);

    /**
     * 校验并批量删除服务商账户信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 递增或递减账户余额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateBalance(Long sydId,long unitId,long amount,String bankType);

    /**
     * 递增或递减冻结金额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateFrozen(Long sydId,long unitId,long amount,String bankType);


    /**
     * 递增或递减账户余额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateBalanceByAccId(int accId,long amount);

    /**
     * 递增或递减冻结金额
     * @author 张涛
     * @date 2021年9月7日
     * @param amount 变动金额（减为复数）
     * @return
     */
    public Integer updateFrozenByAccId(int accId,long amount);

    /**
     * 查询服务商提现账户信息
     * @param id 资金账户id
     * @return
     */
    public SysSydAccountVo getCashoutAccount(Long id);
}
